//
// c r t 0 . S
//
// GBA C runtime startup routine supporting interrupt handlers
//
// June 23, 2003 by Wataru Nishida (http://www.skyfree.org)
//

// Macro definition

#define INT_VECTOR	0x03007FFC	// INT address holder in WRAM

.extern int_handler			// Interrupt handler defined in C

// C runtime startup program

.text

// Cartridge header -- COMMON HEADER FOR ALL PROGRAMS --

	b	start					// Branch to my entry
	.int	0x51AEFF24, 0x21A29A69, 0x0A82843D	// Nintendo logo
	.int	0xAD09E484, 0x988B2411, 0x217F81C0, 0x19BE52A3
	.int	0x20CE0993, 0x4A4A4610, 0xEC3127F8, 0x33E8C758
	.int	0xBFCEE382, 0x94DFF485, 0xC1094BCE, 0xC08A5694
	.int	0xFCA77213, 0x734D849F, 0x619ACAA3, 0x27A39758
	.int	0x769803FC, 0x61C71D23, 0x56AE0403, 0x008438BF
	.int	0xFD0EA740, 0x03FE52FF, 0xF130956F, 0x85C0FB97
	.int	0x2580D660, 0x03BE63A9, 0xE2384E01, 0xFF34A2F9
	.int	0x44033EBB, 0xCB900078, 0x943A1188, 0x637CC065
	.int	0xAF3CF087, 0x8BE425D6, 0x72AC0A38, 0x07F8D421  
	.ascii	"HappyHacking"				// Game title
	.byte	0, 0, 0, 0				// Game code
	.byte	0, 0					// Maker code
	.byte	0x96					// Fixed value
	.byte	0					// Main unit code
	.byte	0					// Device type
	.byte	0, 0, 0, 0, 0, 0, 0			// Reserved
	.byte	0					// ROM version#
	.byte	0x9A					// Complement
	.byte	0, 0					// Check sum

// Program starts...

start:
	ldr	r0, =int_handler	// Tell BIOS to use my "int_handler"
	ldr	r1, =INT_VECTOR		// through an INT vector address in
	str	r0, [ r1 ]		// internal work RAM

	bl	main			// Branch and link to main()
loop:
	b	loop			// Loop forever...
